﻿using SkiaSharp;
using SkiaSharp.Views.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace TransparentBackgroundMaker
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();

            ShowImage();
        }

        void ShowImage()
        {
            SKBitmap source = SKBitmap.Decode(AppResources.Handwriting);

            SKBitmap converted = ConvertToPng(source);

            // Add transparency
            SKBitmap result = AddTransparency(converted, 0.3f);

            // Show in view
            ImageView.Source = SKBitmapImageSource.FromStream(SKImage.FromBitmap((SKBitmap)result).Encode().AsStream);
        }

        private static SKBitmap ConvertToPng(SKBitmap source)
        {
            SKData data = SKImage.FromBitmap(source).Encode(SKEncodedImageFormat.Png, 100);
            SKBitmap converted = SKBitmap.Decode(data);
            return converted;
        }

        SKBitmap AddTransparency(SKBitmap bitmapSource, float treshold)
        {
            var bitmapTarget = bitmapSource.Copy();

            // Calculate the treshold as a number between 0 and 255
            int value = (int)(255 * treshold);

            // loop trough every pixel
            int width = bitmapTarget.Width;
            int height = bitmapTarget.Height;

            for (int row = 0; row < height; row++)
            {
                for (int col = 0; col < width; col++)
                {
                    var color = bitmapTarget.GetPixel(col, row);

                    if (color.Red > value && color.Green > value && color.Blue > value)
                    {
                        bitmapTarget.SetPixel(col, row, color.WithAlpha(0x00));
                    }
                }
            }

            return bitmapTarget;
        }
    }
}
